"""Automatic testing.
"""
import os

### GRU_Dense.py


gru1_sigmoid_configs = {
    'gru0_units': [4, 4, 4, 4, 4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True, True, True, True, True],
    'gru0_in': [False, False, False, False, False, False, False, False, False],

    'gru1_units': [2, 2, 2, 2, 2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [False, False, False, False, False, False, False, False, False],
    'gru1_trainable': [True, True, True, True, True, True, True, True, True],
    'gru1_in': [True, True, True, True, True, True, True, True, True],

    'dense_units': [1, 1, 1, 2, 2, 2, 4, 4, 4],
    'dense_activation': ['sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid'],
    'dense_trainable': [False, False, False, False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE'],
}

gru1_tanh_configs = {
    'gru0_units': [4, 4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True, True],
    'gru0_in': [False, False, False, False, False, False],

    'gru1_units': [2, 2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [False, False, False, False, False, False],
    'gru1_trainable': [True, True, True, True, True, True],
    'gru1_in': [True, True, True, True, True, True],

    'dense_units': [1, 1, 2, 2, 4, 4],
    'dense_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh',],
    'dense_trainable': [False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSE', 'MAE', 'MSE', 'MAE'],
}

gru1_softmax_configs = {
    'gru0_units': [4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True],
    'gru0_in': [False, False, False, False, False],

    'gru1_units': [2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [False, False, False, False, False],
    'gru1_trainable': [True, True, True, True, True],
    'gru1_in': [True, True, True, True, True],

    'dense_units': [2, 2, 2, 2, 2],
    'dense_activation': ['softmax', 'softmax', 'softmax', 'softmax', 'softmax'],
    'dense_trainable': [False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'BCE', 'CCE'],
}


gru01_sigmoid_configs = {
    'gru0_units': [4, 4, 4, 4, 4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True, True, True, True, True],
    'gru0_in': [True, True, True, True, True, True, True, True, True],

    'gru1_units': [2, 2, 2, 2, 2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [False, False, False, False, False, False, False, False, False],
    'gru1_trainable': [True, True, True, True, True, True, True, True, True],
    'gru1_in': [True, True, True, True, True, True, True, True, True],

    'dense_units': [1, 1, 1, 2, 2, 2, 4, 4, 4],
    'dense_activation': ['sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid'],
    'dense_trainable': [False, False, False, False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE'],
}

gru01_tanh_configs = {
    'gru0_units': [4, 4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True, True],
    'gru0_in': [True, True, True, True, True, True],

    'gru1_units': [2, 2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [False, False, False, False, False, False],
    'gru1_trainable': [True, True, True, True, True, True],
    'gru1_in': [True, True, True, True, True, True],

    'dense_units': [1, 1, 2, 2, 4, 4],
    'dense_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh',],
    'dense_trainable': [False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSE', 'MAE', 'MSE', 'MAE'],
}

gru01_softmax_configs = {
    'gru0_units': [4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True],
    'gru0_in': [True, True, True, True, True],

    'gru1_units': [2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [False, False, False, False, False],
    'gru1_trainable': [True, True, True, True, True],
    'gru1_in': [True, True, True, True, True],

    'dense_units': [2, 2, 2, 2, 2],
    'dense_activation': ['softmax', 'softmax', 'softmax', 'softmax', 'softmax'],
    'dense_trainable': [False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'BCE', 'CCE'],
}

sigmoid_configs = {
    'gru0_units': [4, 4, 4, 4, 4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True, True, True, True, True],
    'gru0_in': [True, True, True, True, True, True, True, True, True],

    'gru1_units': [2, 2, 2, 2, 2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [True, True, True, True, True, True, True, True, True],
    'gru1_trainable': [True, True, True, True, True, True, True, True, True],
    'gru1_in': [True, True, True, True, True, True, True, True, True],

    'dense_units': [1, 1, 1, 2, 2, 2, 4, 4, 4],
    'dense_activation': ['sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid', 'sigmoid'],
    'dense_trainable': [False, False, False, False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE', 'MSE', 'MAE', 'MSLE'],
}

tanh_configs = {
    'gru0_units': [4, 4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True, True],
    'gru0_in': [True, True, True, True, True, True],

    'gru1_units': [2, 2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [True, True, True, True, True, True],
    'gru1_trainable': [True, True, True, True, True, True],
    'gru1_in': [True, True, True, True, True, True],

    'dense_units': [1, 1, 2, 2, 4, 4],
    'dense_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh', 'tanh',],
    'dense_trainable': [False, False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSE', 'MAE', 'MSE', 'MAE'],
}

softmax_configs = {
    'gru0_units': [4, 4, 4, 4, 4],
    'gru0_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru0_sequences': [True, True, True, True, True],
    'gru0_trainable': [True, True, True, True, True],
    'gru0_in': [True, True, True, True, True],

    'gru1_units': [2, 2, 2, 2, 2],
    'gru1_activation': ['tanh', 'tanh', 'tanh', 'tanh', 'tanh'],
    'gru1_sequences': [True, True, True, True, True],
    'gru1_trainable': [True, True, True, True, True],
    'gru1_in': [True, True, True, True, True],

    'dense_units': [2, 2, 2, 2, 2],
    'dense_activation': ['softmax', 'softmax', 'softmax', 'softmax', 'softmax'],
    'dense_trainable': [False, False, False, False, False],

    'LOSS': ['MSE', 'MAE', 'MSLE', 'BCE', 'CCE'],
}


for configs in [gru1_sigmoid_configs, gru1_tanh_configs, gru1_softmax_configs, gru01_sigmoid_configs, gru01_tanh_configs, gru01_softmax_configs, sigmoid_configs, tanh_configs, softmax_configs]:

    N_RUNS = len(configs['gru0_units'])

    for run in range(N_RUNS):
        args = []

        for k, v in configs.items():
            args.append(str(v[run]))
        args = ' '.join(args)

        os.system('python3 GRU_Dense.py %s' % args)
